## mingw-w64-adios2-2.11.0-1.src.tar.zst

=== examples/hello/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

add_subdirectory(bpAttributeWriteRead)
add_subdirectory(bpFlushWriter)

if(ADIOS2_HAVE_MPI)
  add_subdirectory(bpFWriteCRead)
endif()

if(ADIOS2_HAVE_SZ)
  add_subdirectory(bpOperatorSZWriter)
endif()

add_subdirectory(bpReader)

add_subdirectory(bpStepsWriteRead)
if(ADIOS2_HAVE_CUDA OR ADIOS2_HAVE_Kokkos_CUDA)
  add_subdirectory(bpStepsWriteReadCuda)
endif()
if(ADIOS2_HAVE_Kokkos_HIP)
  add_subdirectory(bpStepsWriteReadHip)
endif()
if(ADIOS2_HAVE_Kokkos)
  add_subdirectory(bpStepsWriteReadKokkos)
  if(ADIOS2_HAVE_SST)
    add_subdirectory(sstKokkos)
  endif()
  if(ADIOS2_HAVE_DataMan)
    add_subdirectory(datamanKokkos)
  endif()
endif()

add_subdirectory(bpThreadWrite)
add_subdirectory(bpWriter)

if(ADIOS2_HAVE_DataMan)
  add_subdirectory(datamanReader)
  add_subdirectory(datamanWriter)
endif()

if(ADIOS2_HAVE_DataSpaces)
  add_subdirectory(dataspacesReader)
  add_subdirectory(dataspacesWriter)
endif()

if(ADIOS2_HAVE_HDF5)
  add_subdirectory(hdf5Writer)
  add_subdirectory(hdf5Reader)
  if(HDF5_VERSION VERSION_GREATER_EQUAL 1.14)
    add_subdirectory(hdf5SubFile)
  endif()
endif()

add_subdirectory(helloWorld)

if(ADIOS2_HAVE_Fortran)
  add_subdirectory(inlineFWriteCppRead)
endif()

add_subdirectory(inlineMWE)
add_subdirectory(inlineReaderWriter)
add_subdirectory(skeleton)

if(ADIOS2_HAVE_SST)
  add_subdirectory(sstReader)
  add_subdirectory(sstWriter)
endif()

if(ADIOS2_HAVE_Derived_Variable)
    add_subdirectory(bpStepsWriteReadDerived)
endif()

=== examples/basics/variablesShapes/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

cmake_minimum_required(VERSION 3.12)
project(ADIOS2BasicsVariablesShapesExample)

set(maybe_standalone_project OFF)
if(NOT TARGET adios2_core)
  set(maybe_standalone_project ON)
  set(_components CXX)

  find_package(MPI COMPONENTS C)
  if(MPI_FOUND)
    # Workaround for various MPI implementations forcing the link of C++ bindings
    add_definitions(-DOMPI_SKIP_MPICXX -DMPICH_SKIP_MPICXX)

    list(APPEND _components MPI)
  endif()

  find_package(ADIOS2 REQUIRED COMPONENTS ${_components})
endif()

add_executable(adios2_basics_variablesShapes variablesShapes.cpp)
target_link_libraries(adios2_basics_variablesShapes adios2::cxx)
if (maybe_standalone_project)
  install(TARGETS adios2_basics_variablesShapes RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

add_executable(adios2_basics_variablesShapes_hl variablesShapes_hl.cpp)
target_link_libraries(adios2_basics_variablesShapes_hl adios2::cxx)
if (maybe_standalone_project)
  install(TARGETS adios2_basics_variablesShapes_hl RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if(ADIOS2_HAVE_MPI)
  add_executable(adios2_basics_variablesShapes_mpi variablesShapes.cpp)
  target_link_libraries(adios2_basics_variablesShapes_mpi adios2::cxx_mpi MPI::MPI_CXX)
  if (maybe_standalone_project)
    install(TARGETS adios2_basics_variablesShapes_mpi RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
  endif()

  add_executable(adios2_basics_variablesShapes_hl_mpi variablesShapes_hl.cpp)
  target_link_libraries(adios2_basics_variablesShapes_hl_mpi adios2::cxx_mpi MPI::MPI_CXX)
  if (maybe_standalone_project)
    install(TARGETS adios2_basics_variablesShapes_hl_mpi RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
  endif()
endif()

=== examples/useCases/insituGlobalArrays/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

cmake_minimum_required(VERSION 3.12)
project(ADIOS2UseCasesInSituGlobalArraysExample)

set(maybe_standalone_project OFF)

if(NOT TARGET adios2_core)
  set(maybe_standalone_project ON)
  set(_components CXX)

  find_package(MPI COMPONENTS C)
  if(MPI_FOUND)
    # Workaround for various MPI implementations forcing the link of C++ bindings
    add_definitions(-DOMPI_SKIP_MPICXX -DMPICH_SKIP_MPICXX)

    list(APPEND _components MPI)
  endif()

  find_package(ADIOS2 REQUIRED COMPONENTS ${_components})
endif()


add_executable(adios2_useCases_insituGlobalArraysWriter insituGlobalArraysWriter.cpp)
target_link_libraries(adios2_useCases_insituGlobalArraysWriter adios2::cxx)
if (maybe_standalone_project)
install(TARGETS adios2_useCases_insituGlobalArraysWriter RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

add_executable(adios2_useCases_insituGlobalArraysReaderNxN insituGlobalArraysReaderNxN.cpp)
target_link_libraries(adios2_useCases_insituGlobalArraysReaderNxN adios2::cxx)
if (maybe_standalone_project)
install(TARGETS adios2_useCases_insituGlobalArraysReaderNxN RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if(ADIOS2_HAVE_MPI)
  add_executable(adios2_useCases_insituGlobalArraysWriter_mpi insituGlobalArraysWriter.cpp)
  target_link_libraries(adios2_useCases_insituGlobalArraysWriter_mpi adios2::cxx_mpi MPI::MPI_CXX)
  if (maybe_standalone_project)
  install(TARGETS adios2_useCases_insituGlobalArraysWriter_mpi RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
  endif()

  add_executable(adios2_useCases_insituGlobalArraysReaderNxN_mpi insituGlobalArraysReaderNxN.cpp)
  target_link_libraries(adios2_useCases_insituGlobalArraysReaderNxN_mpi adios2::cxx_mpi MPI::MPI_CXX)
  if (maybe_standalone_project)
  install(TARGETS adios2_useCases_insituGlobalArraysReaderNxN_mpi RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
  endif()
endif()

=== source/utils/bp4dbg/CMakeLists.txt ===
install(PROGRAMS bp4dbg.py
  RENAME bp4dbg
  DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT adios2_scripts-runtime
  ${ADIOS2_MAYBE_EXCLUDE_FROM_ALL}
)
install(
  FILES
    adios2/bp4dbg/__init__.py
    adios2/bp4dbg/data.py
    adios2/bp4dbg/utils.py
    adios2/bp4dbg/metadata.py
    adios2/bp4dbg/idxtable.py
  DESTINATION ${CMAKE_INSTALL_PYTHONDIR}/adios2/bp4dbg COMPONENT adios2_scripts-runtime
  ${ADIOS2_MAYBE_EXCLUDE_FROM_ALL}
)

=== testing/adios2/yaml/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

gtest_add_tests_helper(YAMLTimeSeries MPI_NONE "" "" "")
foreach(tgt IN LISTS Test.YAMLTimeSeries-TARGETS)
  target_compile_definitions(${tgt} PRIVATE
    "YAML_CONFIG_DIR=${CMAKE_CURRENT_SOURCE_DIR}"
  )
endforeach()
#target_compile_definitions(${Test.YAMLTimeSeries} PRIVATE 
#  "YAML_CONFIG_DIR=${CMAKE_CURRENT_SOURCE_DIR}"
#)


gtest_add_tests_helper(YAMLConfig MPI_ALLOW "" "" "")

foreach(tgt IN LISTS Test.YAMLConfig-TARGETS)
  target_compile_definitions(${tgt} PRIVATE
    "YAML_CONFIG_DIR=${CMAKE_CURRENT_SOURCE_DIR}"
  )
endforeach()

=== testing/adios2/engine/common/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

find_package(Threads REQUIRED)

add_executable(Test.Engine.Common.MPI TestEngineCommon.cpp)
target_link_libraries(Test.Engine.Common.MPI PRIVATE
  adios2::cxx_mpi
  MPI::MPI_CXX
  adios2::thirdparty::gtest
  ${CMAKE_THREAD_LIBS_INIT}
)

# Note: extra arguments
#   1st arg: Engine
#   2nd arg: 1 for serialized execution, 0 for concurrent execution of Writer/Reader
#   3rd arg: engine parameters

gtest_add_tests_helper(Common MPI_ONLY "" Engine. .File
  EXTRA_ARGS "File" "1"
)

if(ADIOS2_HAVE_HDF5 AND HDF5_IS_PARALLEL)
  gtest_add_tests_helper(Common MPI_ONLY "" Engine. .HDF5
    EXTRA_ARGS "HDF5" "1"
    )
endif()

if(ADIOS2_HAVE_SST)
  gtest_add_tests_helper(Common MPI_ONLY "" Engine. .SST.FFS
    EXTRA_ARGS "SST" "0" "MarshalMethod:FFS"
  )
  gtest_add_tests_helper(Common MPI_ONLY "" Engine. .SST.BP
    EXTRA_ARGS "SST" "0" "MarshalMethod:BP"
  )
endif()

if(NOT MSVC)
  gtest_add_tests_helper(Common MPI_ONLY "" Engine. .SSC
    EXTRA_ARGS "SSC" "0"
    )
endif()

gtest_add_tests_helper(Common MPI_ONLY "" Engine. .BP5
  EXTRA_ARGS "BP5" "1")

gtest_add_tests_helper(Common MPI_ONLY "" Engine. .BP3
  EXTRA_ARGS "BP3" "1")

#if(ADIOS2_HAVE_DataMan)
#  gtest_add_tests_helper(Common MPI_ONLY "" Engine. .DataMan
#    EXTRA_ARGS "DataMan" "0"
#  )
#endif()

=== testing/adios2/engine/time-series/CMakeLists.txt ===
# ------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
# ------------------------------------------------------------------------------#
include(ADIOSFunctions)

set(BP3_DIR ${CMAKE_CURRENT_BINARY_DIR}/bp3)
set(BP4_DIR ${CMAKE_CURRENT_BINARY_DIR}/bp4)
set(BP5_DIR ${CMAKE_CURRENT_BINARY_DIR}/bp5)

# set(HDF5_DIR ${CMAKE_CURRENT_BINARY_DIR}/hdf5)
file(MAKE_DIRECTORY ${BP3_DIR})
file(MAKE_DIRECTORY ${BP4_DIR})
file(MAKE_DIRECTORY ${BP5_DIR})

# file(MAKE_DIRECTORY ${HDF5_DIR})
macro(ts_gtest_add_tests_helper testname mpi)
    gtest_add_tests_helper(${testname} ${mpi} "" Engine.TimeSeries. .BP3
        WORKING_DIRECTORY ${BP3_DIR} EXTRA_ARGS "BP3"
    )
    gtest_add_tests_helper(${testname} ${mpi} "" Engine.TimeSeries. .BP4
        WORKING_DIRECTORY ${BP4_DIR} EXTRA_ARGS "BP4"
    )
    gtest_add_tests_helper(${testname} ${mpi} "" Engine.TimeSeries. .BP5
        WORKING_DIRECTORY ${BP5_DIR} EXTRA_ARGS "BP5"
    )

    # # HDF5 does not work properly with Changing Shapes, so this test would fail too
    # if(ADIOS2_HAVE_HDF5)
    # gtest_add_tests_helper(${testname} ${mpi} "" Engine.TimeSeries. .HDF5
    # WORKING_DIRECTORY ${HDF5_DIR} EXTRA_ARGS "HDF5"
    # )
    # endif(ADIOS2_HAVE_HDF5)
endmacro()

ts_gtest_add_tests_helper(TimeSeries MPI_ALLOW)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=ADIOS2
pkgbase=mingw-w64-${_realname,,}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname,,}")
pkgver=2.11.0
pkgrel=1
pkgdesc="The Adaptable Input/Output System version 2 (mingw-w64)"
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://adios2.readthedocs.io/en/latest/"
msys2_repository_url="https://github.com/ornladios/ADIOS2/"
msys2_references=(
  'archlinux: adios2'
)
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-aws-sdk-cpp"
         "${MINGW_PACKAGE_PREFIX}-blosc2"
         "${MINGW_PACKAGE_PREFIX}-bzip2"
         "${MINGW_PACKAGE_PREFIX}-cc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libsodium"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread"
         "${MINGW_PACKAGE_PREFIX}-openssl"
         "${MINGW_PACKAGE_PREFIX}-pugixml"
         "${MINGW_PACKAGE_PREFIX}-yaml-cpp"
         "${MINGW_PACKAGE_PREFIX}-sqlite3"
         "${MINGW_PACKAGE_PREFIX}-zeromq"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-libffi"
             "${MINGW_PACKAGE_PREFIX}-nlohmann-json"
             "${MINGW_PACKAGE_PREFIX}-pybind11"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-python-numpy")
source=(https://github.com/ornladios/ADIOS2/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz
        001-fix-build-on-mingw-w64.patch
        002-fix-build-on-clangarm64.patch
        003-no-regex_h-with-clang.patch)
sha256sums=('0a2bd745e3f39745f07587e4a5f92d72f12fa0e2be305e7957bdceda03735dbf'
            'cc40a00849ca86d43f1243a108b72058194020fa8043c3fa4b4d42a30e2e9906'
            '0f365062c19c21cda137ccacbf1dd33bd00afdc3418299e2abae8aab5fba33b0'
            '379fe5edf3df2474edfe6515e0592af681c17f082fb4885b5cd554bdee11cd36')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}
  apply_patch_with_msg \
    001-fix-build-on-mingw-w64.patch \
    002-fix-build-on-clangarm64.patch \
    003-no-regex_h-with-clang.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CARCH} == aarch64 ]]; then
    _extra_config+=("-DDILL_NATIVE_ONLY=OFF" "-DDILL_IGNORE_NATIVE=ON")
  fi

  LDFLAGS+=" -Wl,--export-all-symbols" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${_extra_config[@]}" \
    -DBUILD_SHARED_LIBS=ON \
    -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
    -DADIOS2_USE_EXTERNAL_DEPENDENCIES=ON \
    -DADIOS2_USE_AWSSDK=ON \
    -DADIOS2_USE_Blosc2=ON \
    -DADIOS2_USE_BZip2=ON \
    -DADIOS2_USE_Campaign=ON \
    -DADIOS2_USE_DataMan=ON \
    -DADIOS2_USE_Fortran=ON \
    -DADIOS2_USE_HDF5=ON \
    -DADIOS2_USE_HDF5_VOL=ON \
    -DADIOS2_USE_OpenSSL=ON \
    -DADIOS2_USE_Python=ON \
    -DADIOS2_USE_PNG=ON \
    -DADIOS2_USE_Sodium=ON \
    -DADIOS2_USE_ZeroMQ=ON \
    -DADIOS2_USE_DataMan=OFF \
    -DADIOS2_USE_DataSpaces=OFF \
    -DADIOS2_USE_Endian_Reverse=OFF \
    -DADIOS2_USE_IME=OFF \
    -DADIOS2_USE_MGARD=OFF \
    -DADIOS2_USE_MPI=OFF \
    -DADIOS2_USE_Profiling=OFF \
    -DADIOS2_USE_SST=OFF \
    -DADIOS2_USE_SZ=OFF \
    -DADIOS2_USE_ZFP=OFF \
    -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    -DADIOS2_BUILD_EXAMPLES=OFF \
    -DEVPATH_TRANSPORT_MODULES=OFF \
    -DBUILD_TESTING=OFF \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  MSYS2_ARG_CONV_EXCL="-p" python -m compileall \
  -o 0 -o 1 -q -s"${pkgdir}" -p"/" "${pkgdir}${MINGW_PREFIX}/lib"

  install -D -m644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/${_realname,,}/LICENSE
}
